### Method

# Camel Service authenticate

since: 3.4

#### Declaration [src]

    void
    camel_service_authenticate (
      CamelService* service,
      const gchar* mechanism,
      gint io_priority,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description [src]

Asynchronously attempts to authenticate `service` using `mechanism` and, if necessary, `service`‘s `CamelService:password` property. The function makes only ONE attempt at authentication and does not loop.

Generally this function should only be called from a `CamelSession` subclass in order to implement its own authentication loop.

When the operation is finished, `callback` will be called. You can then call `camel_service_authenticate_finish()` to get the result of the operation.

Available since: 3.4

This method completes asynchronously. Use `camel_service_authenticate_finish()` inside the `GAsyncReadyCallback` to obtain the result of the operation.

#### Parameters

`mechanism`

  Type: `const gchar*`

  A SASL mechanism name, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`io_priority`

  Type: `gint`

  The I/O priority of the request.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`callback`

  Type: `GAsyncReadyCallback`

  A `GAsyncReadyCallback` to call when the request is satisfied.

  The argument can be `NULL`.

`user_data`

  Type: `gpointer`

  Data to pass to the callback function.

  The argument can be `NULL`.
  The data is owned by the caller of the method.